(*

Pascal Decryption Unit for the SEAPA System.
Decodes all BSKYB Channels, TVX, aldult, eurotica.

Based upon:

SKY09PU1.ZIP by Thomas
SEASON95     by VONRAT ASO.
LUDI161.ZIP  by DarkSurfer  {  1.8. }
S95_140.ZIP  by G           { 15.8. }

THANX

additional thanks to
Markus, Ludwig, Thomas S., Bernd...

*)

{$R-;Q-}
unit ecm15_8;

interface
uses seascom10;

type data=array[0..32] of Byte;
var mod08,mod81,mod83,modaa,mod7e,modfe,
    modc0,modbf,modee,mod88            :byte;
    oi                                 :byte;
    indata,outdata                     :data;
    perry_smith                        :boolean;
    oldx,oldy:byte;


function Decode:Word;

implementation
uses crt,bskyb09,number;
{ Der _geheime_ Adultkey! Ist eigentlich nur 32Byte lang.
  Die mittleren 32Bytes sind aus einer alten source. }

const adultkey:array[0..95] of byte=
      ($48,$9b,$4d,$a6,$f9,$d9,$df,$6e,
       $ac,$84,$fa,$8b,$2e,$b6,$76,$19,
       $c1,$b0,$a3,$bb,$0c,$fd,$70,$72,
       $ca,$55,$ef,$a0,$7f,$bf,$59,$ad,

       $56,$f2,$b6,$4f,$c9,$bd,$2a,$b3,
       $90,$81,$5d,$ed,$05,$b5,$b9,$26,
       $67,$3c,$65,$a0,$ba,$39,$c7,$af,
       $33,$24,$47,$a6,$20,$1e,$14,$6f,

       $48,$9b,$4d,$a6,$f9,$d9,$df,$6e,
       $ac,$84,$fa,$8b,$2e,$b6,$76,$19,
       $c1,$b0,$a3,$bb,$0c,$fd,$70,$72,
       $ca,$55,$ef,$a0,$7f,$bf,$59,$ad);


var    aoffset:word;

(* ADULT CHANNEL , EUROTICA and
   SKY07 _secret_ hashfunction  *)

procedure kernel_a(var out:data;var oi:Byte;ind:Byte);
var c:Byte;
begin
  out[oi]:=out[oi] xor ind;
  c:=not (adultkey[aoffset+out[oi] shr 4] + adultkey[aoffset+(out[oi] and $f)+16]);
  c:=(c shl 1) or (c shr 7);
  c:=c+ind;
  c:=(c shr 3) or (c shl 5);
  oi:=(oi+1) and 7;
  out[oi]:=out[oi] xor c;
end;

function adecode(var idata,out:data):byte;
var i,key:byte;
const oi:byte=0;
      check:Word=0;
      b:byte=0;
begin
  oi:=0; { oi zhlt von 0-7 und bestimmt im hash,
           in welches Feld der 78er msg geschrieben
           wird. }
  for i:=0 to 7 do out[i]:=0;
  { 27 mal normal durch den Hash mit indata[0..26] }
  for i:=0 to 26 do kernel_a(out,oi,idata[i]);
  {  4 mal doppelt durch den Hash mit indata[27..30],
     zustzlich Integrittsprfung }
  for i:=27 to 30 do begin
    kernel_a(out,oi,b);
    kernel_a(out,oi,b);
    b:=idata[i];
    if out[oi]<>idata[i] then check:=check or 1;
    oi:=(oi+1) and 7;
  end;
  if perry_smith then key:=$d           { Perry Smith ECM 24.5.95 }
                 else key:=idata[31];   { old adult- sky07- jstv??? code }
  for i:=0 to 63 do kernel_a(out,oi,key);
  { checksum prfen }
  b:=0; for i:=0 to 31 do b:=b+idata[i];
  if b<>0 then check:=check or 2;
  out[7]:=out[7] and $f;
  adecode:=check;
end;


(* BSKYB 09Card Hashfunction *)

procedure kernel_b(ind:Byte);
var a,b,c,d,i:Byte;
    m:Word;
label ende;
begin
  if indata[1] and 8 = 0 then goto ende;
  a:=ind; i:=0;
  while i<=4 do begin
    b:=outdata[i] and $3f;
    if indata[1] <= 8
      then if indata[1]=2 then b:=ext_ee[$06e9+b]
                          else if (indata[1]<2) and (b=0)
                                 then b:=ext_ee[$0736+b]
                                 else b:=ext_ee[$06a9+b] xor ext_ee[$0741+b]
      else b:=ext_ee[$06a9+b] xor ext_ee[$0741+b];
    c:=a+b-outdata[i+1];
    d:=(outdata[i]-outdata[i+1]) xor a;
    m:=d*c;
    ext_ee[$00e7]:=m shr 8; { changes the cards R A M !!!
                              ECM 15.6. }
    outdata[i+2]:=outdata[i+2] xor (m and $ff);
    outdata[i+3]:=outdata[i+3] + (m shr 8);
    a:=(a shl 1) or (a shr 7);
    a:=a+$49;
    i:=i+2;
  end; {WHILE DO}
  m:=outdata[6]*outdata[7];
  a:=(m and $ff) + outdata[0];
  if a<outdata[0] then inc(a);
  outdata[0]:=a+$39;
  a:=(m shr 8) + outdata[1];
  if a<outdata[1] then inc(a);
  outdata[1]:=a+$8f;
  oi:=7;
ende:
end;

function bdecode:Word;
var nanos:array[0..15] of byte;
    nano,card_command:byte;
    i,j:word;
    done,doit:boolean;
    xx,akk,xre:byte;
    eepoint:word;
    eedta,ee_offset:byte;
const check:word=0;
      rom_page:word=1;
      b:byte=0;
label ende;
begin
  { Variablen initialisieren }
  eepoint:=0; ee_offset:=0; xx:=0; rom_page:=1; oi:=0;
  for i:=0 to 7 do outdata[i]:=0;
  for i:=0 to $f do nanos[i]:=0;
  oi:=0;

  { Nanos + card_command berechnen }
  xx:=indata[1] xor indata[2];
  xx:=(xx shr 4) or (xx shl 4); { nibbles vertauschen }
  b:=indata[2];

  for i:=0 to 3 do begin
    b:=(b shl 1) or (b shr 7);
    nanos[i]:=xx+b;
    b:=nanos[i];
  end;

  { Das card_command bestimmt, was die 74er msg bewirkt:
    bei $80 wird eine 78er msg berechnet (fr uns interessant),
    bei anderen werden Karten oder einzelne Channels
    freigeschaltet und blockiert oder auch Karten zerschossen.
    Nheres dazu steht in den DETAILS.TXT.
    Ach ja, interessant ist noch, da man fr das card_command,
    die secret_hash_function *nicht* kennen mu. }

  card_command:=nanos[0] xor indata[3];

  for i:=0 to $0b do kernel_b(indata[i]);

  xx:=nanos[2];
  for i:=0 to $e do begin
    nanos[i]:=xx xor indata[i+$c];
    kernel_b(indata[i+$c]);
  end;

  { check the signature }
  xx:=0; check:=0;
  for i:=$1b to $1e do begin
    kernel_b(xx);
    kernel_b(xx);
    xx:=indata[i];
    if outdata[7]<>xx then begin
      { no SKY09 code ... try TAC und eurotica }
      check:=adecode(indata,outdata);
      if check=0 then goto ende;
      for i:=0 to 7 do outdata[i]:=0;
      outdata[0]:=1;
      goto ende;
    end;
  end;

  { nur Verschlsselungscommandos bearbeiten }
  if (card_command=$80) then begin
    SendTo($60); { send 'wait', das verhindert auf langsameren Computer,
                   da der Decoder einen Timeout hat. }
    GotoXY(15,8); for i:=0 to $e do Write(Hex8(nanos[i]),' ');
    GotoXY(14,9); Write('':66); GotoXY(14,9);

    { Nanocommands ausfhren }
    xx:=0;              { xx ist ein Zhler, der das akt. nano adressiert }
    done:=false;        { bei done:=true, wird die Abarbeitung
                          der nanos abgebrochen }
    repeat
      nano:=nanos[xx];  { das aktuelle nano_command }
      doit:=true;       { bei doit:=true werden nach jedem (abgearbeiteten)
                          nano, zwei weitere Byte durch den kernel getrieben:
                          die Variablen akk und xre }
      Write(' N',hex8(nano));
      case nano of
        $03 : begin
                { durch done:=true wird die Abarbeitung der nanos abgebrochen }
                akk:=xx; xre:=$03; doit:=false; done:=true;
              end;
        $09 : begin
                { eepoint ist ein Pointer fr das $30 nano }
                eepoint:=nanos[xx+1]*$100+nanos[xx+2];
                akk:=$63; xre:=$00; xx:=xx+3;
              end;
        $0f : begin                    { ECM 1.8. }
                { bricht wie das $03 nano die Abarbeitung des nanos ab }
                modaa:=nanos[xx+1]; done:=true;
              end;
        $11 : begin
                { hier wird eine Adresse im EEPROM??(RAM??) gebildet,
                  fr der Inhalt ein neuer Wert bestimmt wird,
                  der dann in einem folgenden $30 nano abgefragt
                  wird.
                  Das nennt man Subnanoscommands, das subnano ist
                  gleich der oben beschriebenen Adresse.
                  Mit diesen subnanos knnen noch andere Aktionen
                  bewirkt werden. Da wren die Umschaltung der
                  rom_page oder das berspringen eine nanocommands. }
                eepoint:=nanos[xx+2]*$100+nanos[xx+3];
                eedta:=nanos[xx+1];
                Write(' S',hex8(eepoint));

                { Subnanocommands bearbeiten }
                case eepoint of
{ ECM 17.5 }      $08 : begin
                          { diese entscheidet, welche
                            rom_page addressiert wird }
                          mod08:=eedta;
                          case mod08 of
                            $c0 : rom_page:=2;
                            $40 : rom_page:=1;
                          end;
                        end;
                  $81 : begin eedta:=eedta and $b7; eedta:=eedta or $40;
                          mod81:=eedta;
                        end;
{ ECM 1.8. }      $c0 : begin
                          { Dies ist der normale Typ, eines Subnanos,
                            Der Inhalt der Romadresse $c0 wird ver-
                            ndert und im RAM?? EEPROM??? gespeichert. }
                          modc0:=eedta; end;
                  $fe : begin modfe:=eedta; end;
                  $aa : begin modaa:=eedta; end;
{ ECM 1.8.}       $bf : begin modbf:=eedta; end;
{ ECM 15.8. }     $ee : begin
                          { es wird zustzlich, das nchste
                            $30 nano bersprungen. }
                          modee:=eedta; xx:=xx+2;
                        end;
{ ECM 15.8. }     $88 : begin end;
                  else  outmsg('unkown subnano command '+hex8(eepoint));
                end;
                akk:=eedta; xre:=0; xx:=xx+4;
              end;
        $19 : begin akk:=xx; xre:=$19; xx:=xx+1; end;
        $28 : begin akk:=nanos[xx+4]; xre:=xx; xx:=xx+5; end;
        $30 : begin ee_offset:=nanos[xx+1];
                { Das Monster nano ;-) Hier werden die Subnanos aus
                  frheren $11 nanos abgearbeiten. Auerdem wird hier
                  die Variable eepoint aus den nanos $09 und $11 verwendet.
                  Weil das anscheinend noch nicht genug ist ;-), wird
                  die rom_page 2 hier benutzt. }
                repeat
(*                  if eepoint+ee_offset in [$08,$81,$aa,$7e,$fe,$c0,$bf,$ee,$88] then
                  begin write('/'+hex8(eepoint+ee_offset)); end;  { zum debuggen } *)
                  { rompage switching   ECM 17.5. }
                  if rom_page=1 then eedta:=ext_ee[eepoint+ee_offset]
                                else eedta:=ext_ee[eepoint+ee_offset+$2000-$1100];
                  { testen, ob subnanos aus frheren $11 nanos adressiert werden }
                  case eepoint+ee_offset of
                    $08:eedta:=mod08; { ECM 17.5. }
                    $81:eedta:=mod81;
                    $aa:eedta:=modaa;
                    $7e:eedta:=modfe;
                    $fe:eedta:=modfe;
                    $c0:eedta:=modc0; { ECM 1.8. }
                    $bf:eedta:=modbf; { ECM 1.8. }
                    $ee:eedta:=modee; { ECM 15.8. }
                  end;
                  kernel_b(eedta);
                  ee_offset:=ee_offset-1;
                until ee_offset>$80; { G meint, dies sei der 'Vampier' Hack ;-) }
                akk:=eedta; xre:=ee_offset; xx:=xx+2;
              end;
        $39 : begin akk:=nanos[xx+1]; xre:=$00; xx:=xx+2; end;
        $46 : begin
                { hier wird die Berechnung ganz! aufbebrochen,
                  die 78er msg ist so fertig, wie im Moment ist }
                outdata[7]:=outdata[7] and $0f;
                if check and 1=0 then goto ende;
                for i:=0 to 7 do outdata[i]:=0;
                outdata[0]:=1; goto ende;
              end;
        else  begin
                { dummy-routine fr zuknftig, unbekannte nanos }
                akk:=0; xre:=0; xx:=xx+1;
                done:=true; doit:=false;
                outmsg('unkown nanocommand '+hex8(nano));
              end;
      end; {CASE nano of}
      if doit then begin kernel_b(akk); kernel_b(xre); end
    until (xx>$f) or (done);

  end {IF card_command ... }
  else case card_command of
   { zu den card_commands siehe DETAILS.TXT }
   $00..$2c:begin end;
   $40:outmsg('pay-per-view account management command');
   $f0:outmsg('probably new ECM '+hex8(card_command));
   $81,$f1,$92:begin end; { don't know whatfore those are, do you? }
   else outmsg('unkown card_command '+hex8(card_command));
  end;

  { last 64 iterations }
  if indata[0] and 8=0 then goto ende;
  for i:=0 to $3f do kernel_b(xx);
  outdata[7]:=outdata[7] and $0f;

  { test checksum }
  b:=0;
  for i:=0 to $1f do b:=b+indata[i];
  if b<>0 then check:=check or 2;
  if check and 1=0 then goto ende; { alles richtig }

  outmsg('checksum error');
  for i:=0 to 7 do outdata[i]:=0;
  outdata[0]:=1;

  ende:
  outdata[7]:=outdata[7] and $0f;
end;

{ **** Entscheidung SKY09 or ADULT **** }
function decode:word;
begin
  { indata[6] ist das channel-id }
  case indata[6] of
    $08,$21,$22,$23,$26,$2c:bdecode;
    $01,$52,$63            :adecode(indata,outdata);
    else bdecode;
  end;
end;

begin
end.